unit Matrice;

interface

const
   MAX = 100;

type	    
   TMatrice = record
		 contenu : array[1..MAX] of Real;
		 largeur : Integer;
		 hauteur : Integer;
	      end;	 

function matriceZero(hauteur,largeur :  Integer) : TMatrice;
function largeur(m :  TMatrice) : Integer;
function hauteur(m :  TMatrice) : Integer;  
function obtenir(m : TMatrice; jHauteur, iLargeur : Integer) : Real;
procedure fixer(var m : TMatrice; jHauteur, iLargeur : Integer; val : Real);

implementation 

function position(m : TMatrice; jHauteur, iLargeur : Integer) : Integer;
begin
   position:=m.largeur*jHauteur-1+iLargeur
end; { position }

function largeur(m :  TMatrice) : Integer;
begin
   largeur:=m.largeur
end; { largeur }

function hauteur(m :  TMatrice) : Integer;
begin
   hauteur:=m.hauteur
end; { hauteur }

function matriceZero(hauteur,largeur :  Integer) : TMatrice;
var
   m   : TMatrice;
   i,j : Integer;
begin
   m.largeur:=largeur;
   m.hauteur:=hauteur;
   for i:=1 to largeur do
      for j:=1 to hauteur do
	 m.contenu[position(m,j,i)]:=0;
   matriceZero:=m;
end; { matriceZero }

function obtenir(m : TMatrice; jHauteur, iLargeur : Integer) : Real;
begin
   obtenir:=m.contenu[position(m,jHauteur,iLargeur)]
end; { obtenir }

procedure fixer(var m : TMatrice; jHauteur, iLargeur : Integer; val : Real);
begin
   m.contenu[position(m,jHauteur,iLargeur)]:=val
end; { fixer }

end.
